pipeline {
    agent {
        label 'your-agent-label'  // Replace with your agent's label
    }
    stages {
        stage('Checkout') {
            steps {
                git credentialsId: 'your-repo-credentials', url: 'your-repo-url'
            }
        }
        stage('Build') {
            steps {
                sh './gradlew clean build'
            }
        }
        stage('Test') {
            steps {
                sh './gradlew test'
            }
        }
        stage('Database Migration') {
            steps {
                sh './migrate_db.sh'
            }
        }
        stage('Deploy') {
            steps {
                sh 'pkill -f \'java -jar\''
                sh 'nohup java -jar build/libs/HealthCare-0.0.1-SNAPSHOT.jar --server.port=8081 > app.log 2>&1 &'
            }
        }
    }
    post {
        always {
            echo "Pipeline finished"
        }
        success {
            echo "Pipeline succeeded"
        }
        failure {
            echo "Pipeline failed"
            mail to: 'your-email@example.com',
                 subject: "Jenkins Pipeline Failed",
                 body: "The pipeline ${env.JOB_NAME} build ${env.BUILD_NUMBER} failed."
        }
    }
}